"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
/** Represents a tribe member */
var Member = /** @class */ (function (_super) {
    __extends(Member, _super);
    /**
     * @hidden
     */
    function Member(client, member) {
        if (member === void 0) { member = {}; }
        var _this = _super.call(this, client) || this;
        Object.assign(_this, member);
        return _this;
    }
    /**
     * Returns member data from a packet
     *
     * @hidden
     */
    Member.prototype.read = function (packet) {
        this.id = packet.readInt();
        this.name = packet.readUTF();
        this.gender = packet.readByte();
        packet.readInt(); // ?
        this.lastConnection = packet.readInt();
        this.rankId = packet.readByte();
        this.gameId = packet.readInt();
        this.roomName = packet.readUTF();
        return this;
    };
    Object.defineProperty(Member.prototype, "rank", {
        /**
         * The rank of the member
         */
        get: function () {
            return this.tribe.ranks[this.rankId];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Member.prototype, "isConnected", {
        /**
         * If the player is connected
         */
        get: function () {
            return this.gameId !== 1;
        },
        enumerable: false,
        configurable: true
    });
    return Member;
}(_1.Player));
exports.default = Member;
